unit princ;
{Tablettes - programme d'aide  la lecture du latin.

Copyright (C) 2001 Y. Ouvrard.

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le
modifier conformment aux dispositions de la Licence Publique Gnrale GNU,
telle que publie par la Free Software Foundation ; version 2 de la licence,
ou encore ( votre choix) toute version ultrieure.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION
A UN OBJET PARTICULIER.
Pour plus de dtail, voir la Licence Publique Gnrale GNU .
Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la
Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
Pour tout contact avec les auteurs : yves.ouvrard@collatinus.com}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, StdCtrls, ExtCtrls, UMorpho;

type
  TFPrinc = class(TForm)
    MainMenu1: TMainMenu;
    OpenDialog: TOpenDialog;
    FindDialog: TFindDialog;
    auteur1: TMenuItem;
    Fichier1: TMenuItem;
    Nouveau1: TMenuItem;
    Ouvrir1: TMenuItem;
    Edition1: TMenuItem;
    Modifierlelatin1: TMenuItem;
    Chercher2: TMenuItem;
    N1: TMenuItem;
    Quitter2: TMenuItem;
    EnregistrerBlocNotes1: TMenuItem;
    SaveDialog: TSaveDialog;
    plusgros1: TMenuItem;
    pluspetit1: TMenuItem;
    RichE: TRichEdit;
    Memo1: TRichEdit;
    PopupMenu1: TPopupMenu;
    StatusBar: TStatusBar;
    Splitter1: TSplitter;
    procedure FormCreate(Sender: TObject);
    procedure RichEMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FindDialogFind(Sender: TObject);
    procedure FindDialogShow(Sender: TObject);
    procedure Effaceretcrire1Click(Sender: TObject);
    procedure chercher1Click(Sender: TObject);
    procedure auteur1Click(Sender: TObject);
    procedure quitter1Click(Sender: TObject);
    procedure ouvrirunfichier1Click(Sender: TObject);
    procedure Modifierlelatin1Click(Sender: TObject);
    procedure EnregistrerBlocNotes1Click(Sender: TObject);
    procedure plusgros1Click(Sender: TObject);
    procedure pluspetit1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure InsereEntree(Sender: TObject);
    procedure InsereMorpho(Sender: TObject);
    procedure InsereTraduction(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure RichESelectionChange(Sender: TObject);
    procedure AjourEtat;
  private       
    { Dclarations prives }
    FLatinEditable: Boolean;
    Eleve, NFEleve : String;
    LeMot : string;
    Entree, morpho, traduction : string;
    nbAidesE, nbAidesM, nbAidesT : integer;
    reptrace : string;
    // droits
    AutoLex : integer;  // popup lexical et morpho
    insereLex : integer;  // insertion du lexique
    insereMorph : integer; // insertion lexique et morpho
    insereTr : integer;   // insertion de la traduction
    evalSyntaxe : integer; // valuation des liens syntaxiques
    Procedure MontreGraphie (
      var HintStr: string;
      var CanShow: Boolean;
      var HintInfo: THintInfo);
    procedure SetLatinEditable(const Value: Boolean);
    procedure TaillePolice (increment : integer);
    procedure Charger (F : String);
    procedure EcrisTrace ( L : string );
  public
    { Dclarations publiques }
    Fichier : String;
    RepTexte : String;
    function Chemin : String;
    property LatinEditable : Boolean read FLatinEditable write SetLatinEditable;
  end;
var
  FPrinc: TFPrinc;

implementation

{$R *.DFM}
Uses Inifiles, MulotEdt, ULex, USyntaxe, utiles, Ulistes, chaines,
  traduction, FlexF;

procedure TFPrinc.FormCreate(Sender: TObject);
  var
    IniFile : TIniFile;
    ChLexique : string;
    ListeAides : TstringList;
begin
  OpenDialog.InitialDir := Chemin; 
  Memo1.Align := alClient;
  Application.OnShowHint := MontreGraphie;
  NFEleve := '';
  Eleve := '';
  ChLexique := chemin + 'collatinus.lex';
  // initialisation des compteurs d'aide
  nbAidesE := 0;
  nbAidesM := 0;
  nbAidesT := 0;

  Inifile := TIniFile.Create(
    ChangeFileExt(Paramstr(0), '.ini'));
  Try
      Fichier := IniFile.ReadString ('Fichier', 'Nom', '');
      RepTexte := IniFile.ReadString ('Sauvegarde', 'repertoire', '');
      ChLexique := IniFile.ReadString('Fichier', 'lexique', ChLexique);
      if Fichier > '' then
        begin
          Charger(Fichier);
          LatinEditable := False;
          if inputQuery('Tablettes', 'ton nom :', Eleve) then
            begin
              RepTexte := RepTexte + '\';   
              NFEleve := RepTexte + Eleve + '-'
                 + ExtractfileName ( fichier );
              if FileExists(NFEleve)
                 then Memo1.Lines.LoadFromFile ( NFEleve );
              if pos('auxil.', Memo1.Lines[0]) > 0 then
                 begin
                    ListeAides := TStringList.Create;
                    ListeAides.CommaText := Memo1.Lines[0];
                    nbAidesE := StrToInt(ListeAides[1]);
                    nbAidesM := StrToInt(ListeAides[2]);
                    nbAidesT := StrToInt(ListeAides[3]);
                    ListeAides.Free;
                    Memo1.Lines.Delete(0);
                 end;
            end;
          // trace
          repTrace := Inifile.ReadString ('Sauvegarde', 'reptrace', '');
          // droits
          AutoLex := IniFile.ReadInteger ('Droits', 'AutoLex', 0);
          insereLex := IniFile.ReadInteger ('Droits', 'insereLex', 1);
          insereMorph := IniFile.ReadInteger('Droits', 'insereMorpho', 2);
          insereTr := IniFile.ReadInteger ('Droits', 'insereTr', 3); 
          evalSyntaxe := IniFile.ReadInteger('Droits', 'evalSyntaxe', 3);
          // affichage
          StatusBar.Show;
          if AutoLex < 1
             then RichE.ShowHint := false;
        end;
      finally
      Inifile.free;
    end;
   LisLexique ( ChLexique );
   Memo1.Modified := false;
   AjourEtat;
end;

procedure TFPrinc.RichEMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  var
    inventum : Boolean;
    L : TStringList;
begin
  Try
    LeMot := REExtractWordFromPos(RichE, X, Y);
    if LeMot = '' then
       begin
          RichE.Hint := '';
          exit;
       end;
    L := AnalysesDe( LeMot, inventum, maAnalyses ) ;
    RichE.Hint := L.Text;
    L.Free;
    except
    RichE.Hint := '?';
    end;
  // A.Free;
end;

procedure TFPrinc.MontreGraphie(var HintStr: string; var CanShow: Boolean;
      var HintInfo: THintInfo);
  begin
    With HintInfo do
      begin
        ReshowTimeout := 100;
      end;
  end;

procedure TFPrinc.FindDialogFind(Sender: TObject);
var
  SelPos: Integer;
begin
  with TFindDialog(Sender) do
  begin
    { Effectuer une recherche globale faisant la diffrence maj/min de FindText           dans Memo1 }
      SelPos := Riche.FindText(FindText, Riche.SelStart + 1,
        Length(Riche.Text), []);
      // Pos(FindText, Riche.Lines.Text);
    if SelPos > 0 then
    begin
      Riche.SelStart := SelPos;
      Riche.SelLength := Length(FindText);
    end
    else MessageDlg(
      Concat('Impossible de trouver "', FindText, '"'),
      mtError, [mbOk], 0);
  end;
end;

procedure TFPrinc.FindDialogShow(Sender: TObject);
begin
  RichE.SelStart := 0;
end;

procedure TFPrinc.Effaceretcrire1Click(Sender: TObject);
begin
  Riche.Clear;
  LatinEditable := True;
end;

procedure TFPrinc.chercher1Click(Sender: TObject);
begin
  FindDialog.execute;
end;

procedure TFPrinc.auteur1Click(Sender: TObject);
begin
ShowMessage(
    'Tablettes 4.01'#13#10'Yves Ouvrard'#13#10'janvier MMII'#13#10
    + 'y.ouvrard@collatinus.com'#13#10'licence GPL ci-jointe');
end;

procedure TFPrinc.quitter1Click(Sender: TObject);
begin
  Close;
end;

procedure TFPrinc.ouvrirunfichier1Click(Sender: TObject);
  var IniFile : TInifile;
begin
With OpenDialog do
  begin
  Inifile := TIniFile.Create(
    ChangeFileExt(Paramstr(0), '.ini'));
  Try
      InitialDir := Inifile.ReadString ('Sauvegarde', 'repertoire', '*.txt');
      if Execute then
        begin
          // RichE.Lines.LoadFromFile(FileName);
          Charger(FileName);
          LatinEditable := False;
          InitialDir := ExtractFilePath(FileName);
        end;
      finally
      Inifile.free;
    end;
  end;
end;

procedure TFPrinc.Modifierlelatin1Click(Sender: TObject);
begin
  with Modifierlelatin1 do
    Begin
      checked := not checked;
      LatinEditable := checked;
    end;
end;

procedure TFPrinc.SetLatinEditable(const Value: Boolean);
begin
  FLatinEditable := Value;
  RichE.ReadOnly := not FLatinEditable;
  Modifierlelatin1.Checked := FLatinEditable;
end;

procedure TFPrinc.EnregistrerBlocNotes1Click(Sender: TObject);
  var FInit : TInifile;
      Fichier : TextFile;
      i : integer;
begin
  // enregistre le bloc notes.
if NFEleve > '' then
  // Memo1.Lines.SaveToFile (NFEleve)
  { 8 oct mmi : essai d'criture dans un rp sans droit de lecture }
     begin
        AssignFile(Fichier, NFEleve);
        Rewrite(Fichier);
        writeln( Fichier, 'auxil.,'
           + format('%d,%d,%d', [nbAidesE, nbAidesM, nbAidesT]));
        For i := 0 to Memo1.lines.count - 1 do
           writeln(Fichier, Memo1.Lines[i]);
        closeFile(Fichier);
        Memo1.Modified := false;
     end
  else
  with SaveDialog do
    begin
      // lire l'init
      FInit :=
        TInifile.Create(ChangeFileExt (Paramstr(0), '.ini'));
      Try
        InitialDir := FInit.ReadString ('Sauvegarde', 'repertoire', NFEleve);
        FileName := NFEleve;
        if Execute then
          begin
            if FileExists(FileName)
              then ShowMessage('Ce fichier existe dj. Trouve un autre nom')
                else
                begin
                  Memo1.Lines.SaveToFile(FileName);                  
                  NFEleve := FileName;
                end;
          end;
        Finally
          FInit.Free;
        end;
    end;
end;

function TFPrinc.Chemin: String;
begin
  Result := ExtractFilePath(Paramstr(0));
end;

procedure TFPrinc.TaillePolice (increment : integer);
begin
  if    (RichE.Font.Size + increment < 33)
    and (RichE.Font.Size + increment > 5) then
      begin
        RichE.Font.Size := RichE.Font.Size + increment;
        Memo1.Font.Size := RichE.Font.Size;
      end;
end;

procedure TFPrinc.plusgros1Click(Sender: TObject);
begin
  TaillePolice(2);
end;

procedure TFPrinc.pluspetit1Click(Sender: TObject);
begin
  TaillePolice (-2);
end;

procedure TFPrinc.Charger(F: String);
begin
  RichE.Clear;
  RichE.paragraph.FirstIndent := 20;
  Memo1.Paragraph.FirstIndent := 20;
  RichE.Lines.LoadFromFile(F);
end;

procedure TFPrinc.PopupMenu1Popup(Sender: TObject);
   var M, Sl, Sm, St : TMenuItem;
       A : TAnalyse;
       L : TListeAnalyses;
       inventum : boolean;
       i : integer;
begin
   with PopupMenu1 do
      begin
         items.Clear;
         M := TMenuItem.Create( Self );
         M.Caption := LeMot;
         // analyser le mot
         L := ListeAnalysesDe ( LeMot, inventum );
         if inventum then
            begin
               M.Visible := true;
               Entree := '';
               Morpho := '';
               Traduction := '';
               For i := 0 to L.count - 1 do
                  begin
                     A := L.Analyse(i);
                     Entree := Entree + ' ' + francais ( A.canon);
                     Morpho := L.Graphie ( maAnalyses ).Text;
                     if A.Numero(0) <> nil
                       then
                       case A.Numero(0).Categorie  of
                          cverbe : Traduction := traduction + ' '
                             + Verbe ( LeMot );
                          cnom :
                            if A.Numero(0).Numerus = 0
                               then Traduction := traduction + ' '
                                  + firstword ( francais ( A.canon))
                               else Traduction := traduction + ' '
                                  +  PlurielNom(firstword(francais(A.canon)));
                           end;
                  end;

               if Entree > '' then
                  begin
                    // lexique
                    if (insereLex > 0) and (Entree > '') then
                       begin
                        Sl := TMenuItem.Create(M);
                        Sl.Caption := '&lexique';
                        Sl.OnClick := InsereEntree;
                        M.Add(Sl);
                       end;
                    // morpho
                    if (insereMorph > 0) and (Morpho > '') then
                       begin
                        Sm := TMenuItem.Create(M);
                        Sm.Caption := 'lexique et &morphologie';
                        Sm.OnClick := InsereMorpho;
                        M.Add(Sm);
                       end;
                    // traduction
                    if (traduction > '') and (insereTr > 0) then
                       begin
                         St := TMenuItem.Create(M);
                         St.Caption := '&traduction';
                         St.OnClick := InsereTraduction;
                         M.Add(St);
                       end;
                  end;
               Items.Add(M);
            end
            else M.Visible := false;
         L.Free;
      end;
end;

procedure TFPrinc.InsereEntree(Sender: TObject);
begin
   Memo1.SelText := ' ' + Entree;
   EcrisTrace('lexique - ' + LeMot);
   inc ( nbAidesE );
   AjourEtat;
end;

procedure TFPrinc.InsereMorpho(Sender: TObject);
begin
   Memo1.SelText := ' ' + Morpho;
   EcrisTrace('morpho - ' + LeMot);
   inc ( nbAidesM );
   AjourEtat;
end;

procedure TFPrinc.InsereTraduction(Sender: TObject);
begin
   Memo1.SelText := ' ' + trim ( Traduction );
   EcrisTrace('traduction - ' + LeMot);
   inc ( nbAidesT );
   AjourEtat;
end;

procedure TFPrinc.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   // enregistrement du travail de l'lve.
   CanClose := true;
   if (Memo1.Modified)
      then EnregistrerBlocNotes1Click(nil);
end;

procedure TFPrinc.RichESelectionChange(Sender: TObject);
   var  primus, ultimus : string;
        Lien : TLienSyntaxique;
        info : string;
begin
{ valuation de la syntaxe :
  si le texte slectionn contient plusieurs mots entiers, et que
  le droit evalsyntaxe est arm, un dialogue s'affiche, demandant
  si on dsire l'valuation des deux extrmes.}
  if evalsyntaxe < 1
     then exit;
   with RichE do
      if (SelText > '') and (pos (' ', trim(SelText)) > 0) then
         begin
            primus := MotSousPos ( RichE, SelStart );
            ultimus := MotSousPos ( RichE, SelStart + SelLength );
            if not (primus[1] in lettres) then primus := '';
            if not (ultimus[1] in lettres) then ultimus := '';
            if (primus > '') and (ultimus > '')
               and (MessageDlg(
                  format (
                     'Afficher les liens possibles entre %s et %s ?',
                     [primus, ultimus]),
                   mtConfirmation,
                   [mbYes, mbNo], 0) = mrYes) then
                begin
                   Lien := TLienSyntaxique.create(primus, ultimus);
                   info := (Lien.resultats.text);
                   Lien.Free;
                   Lien := TLienSyntaxique.create(ultimus, primus);
                   info := info + Lien.resultats.text;
                   Lien.Free;
                   ShowMessage(info);
                   EcrisTrace ( format ('syntaxe - %s-%s', [primus, ultimus]));
                end;
         end;
   RichE.SelLength := 0;
end;

procedure TFPrinc.EcrisTrace(L: string);
   var Fichier : TextFile;
begin
   // crit la ligne L dans le fichier Trace.
if repTrace > '' then
   begin
     AssignFile(Fichier, repTrace);
     if not FileExists(repTrace)
        then rewrite(Fichier)
        else append(Fichier);
     writeln(Fichier, Eleve + ' ' + L);
     closeFile(Fichier);
   end;
end;

procedure TFPrinc.AjourEtat;
begin
  with StatusBar do
     begin
        Panels[0].Text := format('lexique : %d', [nbAidesE]);
        Panels[1].Text := format('morphologie : %d', [nbAidesM]);
        Panels[2].Text := format('traduction : %d', [nbAidesT]);
     end;
end;

end.
